#include<stdio.h>
#include<stdlib.h>
#include<math.h>
#include<string.h>
typedef struct PtlPos{
	float x,y,z;
} PtlPos;
typedef struct PtlVel{
	float vx,vy,vz;
} PtlVel;
void plot_();
void sm_init_();
void sm_draww_();
void sm_boxx_();
#define MIN(A,B) ((A)<(B) ? (A): (B));
#define MAX(A,B) ((A)>(B) ? (A): (B));
int main(int argc,char *argv[]){
	FILE *fp;
	PtlPos *r;
	PtlVel *vr;
	float *x,*y,*z,*vx,*vy,*vz;
	int tnend,nend,i,j,k;
	int *indx;
      int mpeak,np;
      float xmin,ymin,xmax,ymax,width;
	int anend[10000];
	FILE *wp;
	fp = fopen(argv[1],"rb");
	while(fread(&mpeak,sizeof(int),1,fp) ==1) {
		xmin = ymin = 5000;
		xmax = ymax = -29000;
		sm_init_();
		wp = fopen("TMP.DATA","w");
		for(i=0;i<mpeak;i++){
			fread(&nend,sizeof(int),1,fp);
			printf("halo %d has %d particles in %d peaks\n",i,nend,mpeak);
			anend[i] = nend;
			r = (PtlPos *) malloc(nend*sizeof(PtlPos));
			vr = (PtlVel *) malloc(nend*sizeof(PtlVel));
			indx = (int *) malloc(nend*sizeof(int));
			x = (float *) malloc(nend*sizeof(float));
			y = (float *) malloc(nend*sizeof(float));
			fread(r,sizeof(PtlPos),nend,fp);
			fread(vr,sizeof(PtlVel),nend,fp);
			fread(indx,sizeof(int),nend,fp);
			for(j=0;j<nend;j++){
				x[j] = r[j].x;
				y[j] = r[j].y;
				fprintf(wp,"%g %g %g %g %g %g\n",r[j].x,r[j].y,r[j].z,
					vr[j].vx,vr[j].vy,vr[j].vz);
				xmin = MIN(xmin,x[j]);
				ymin = MIN(ymin,y[j]);
				xmax = MAX(xmax,x[j]);
				ymax = MAX(ymax,y[j]);
			}
			free(r);free(vr);free(indx);free(x);free(y);
		}
		fclose(wp);
		width = xmax-xmin;width = MAX(width,ymax-ymin);
		sm_boxx_(&xmin,&ymin,&width);
		wp = fopen("TMP.DATA","r");
		np = 1;
            for(i=0;i<mpeak;i++){
			x = (float *) malloc(anend[i]*sizeof(float));
			y = (float *) malloc(anend[i]*sizeof(float));
			z = (float *) malloc(anend[i]*sizeof(float));
			vx = (float *) malloc(anend[i]*sizeof(float));
			vy = (float *) malloc(anend[i]*sizeof(float));
			vz = (float *) malloc(anend[i]*sizeof(float));
			for(j=0;j<anend[i];j++){
				fscanf(wp,"%g %g %g %g %g %g\n",&x[j],&y[j],&z[j],&vx[j],&vy[j],&vz[j]);
			}
			plot_(x,y,anend+i,&i,&np);
			np += anend[i];
			free(x);free(y);free(z);free(vx);free(vy);free(vz);
		}
		sm_draww_();
		printf("now next?");
		getchar();
		fclose(wp);
	} 
}
