#include<stdio.h>
#include<stdlib.h>
extern float pixmin;
extern int *xhalo[];
extern int *yhalo[];
extern int *nendhalo[];
extern int numhalo[];
int find_halo(float *den,int nx,int ny,int local_nz,int nbuff,int nslice,
		float *val,float HALO_DENSITY_THRESHOLD){
	int *twoDim2oneDim,inum;
	int ij,iy,ix,mk,nend;
	int MAX_HALO_SIZE;
	MAX_HALO_SIZE = nx * ny;
	twoDim2oneDim = (int *) malloc(nx*ny*sizeof(int));
	copyden_(den,&nx,&ny,&local_nz,&nbuff,&nslice,val,twoDim2oneDim,
			&inum,&HALO_DENSITY_THRESHOLD);
	numhalo[nslice] = 0;
	nend = 0;
	for(ij=0;ij<inum;ij++){
		iy = (*(twoDim2oneDim+ij)-1)/nx + 1;  /* ix,iy is in Fortran coord.*/
		ix = *(twoDim2oneDim+ij) - (iy-1)*nx;
		/* ix-1,iy-1 is in C-coordinat */
		if(*(val+(ix-1)+(iy-1)*nx) >= HALO_DENSITY_THRESHOLD){
			numhalo[nslice] = numhalo[nslice] + 1;
			xhalo[nslice] = (int *)realloc(xhalo[nslice],
					(nend+MAX_HALO_SIZE)*sizeof(int));
			yhalo[nslice] = (int *)realloc(yhalo[nslice],
					(nend+MAX_HALO_SIZE)*sizeof(int));
			nendhalo[nslice] = (int *) realloc(nendhalo[nslice],
					numhalo[nslice]*sizeof(int));
			newfindhalo_(&ix,&iy,val,xhalo[nslice]+nend,yhalo[nslice]+nend,
					&mk,&HALO_DENSITY_THRESHOLD,&nx,&ny,&pixmin);
			nend = nend + mk;
			*(nendhalo[nslice]+numhalo[nslice]-1) = nend;
		}
	}
	xhalo[nslice] = (int *)realloc(xhalo[nslice],nend*sizeof(int));
	yhalo[nslice] = (int *)realloc(yhalo[nslice],nend*sizeof(int));
	nendhalo[nslice] = (int *)realloc(nendhalo[nslice],
			numhalo[nslice]*sizeof(int));
	free(twoDim2oneDim);
	return inum;
}
