c234567
      subroutine writefortrandata(numslice,numhalo,xhalo,yhalo,
     &                  numpixel)
	  integer numslice,numhalo
	  integer numpixel(numhalo)
	  integer xhalo(*),yhalo(*)
	  character*1 dir1,dir2,dir3,dir4
	  dir1 = char(48+numslice/1000)
	  dir2 = char(48+mod(numslice,1000)/100)
	  dir3 = char(48+mod(numslice,100)/10)
	  dir4 = char(48+mod(numslice,10))
	  open(1,file='halo'//dir1//dir2//dir3//dir4,form='unformatted',
     &	                access='append')
	  nend = 0
	  do i = 1, numhalo
	      write(1) numpixel(i)-nend
		  write(1) (xhalo(ii),ii=nend+1,numpixel(i))
		  write(1) (xhalo(ii),ii=nend+1,numpixel(i))
		  nend = numpixel(i)
	  enddo
	  close(1)
	  return
	  end
c----------------------------------------------------------------------
      subroutine npdata(nrank,myrank,np,inumber)
      INCLUDE "mpif.h"
	  integer nrank,myrank,np,inumber
	  character*3 number,proc
	  number = char(48+inumber/100)//char(48+mod(inumber/10,10))//
     &         char(48+mod(inumber,10))
	  proc = char(48+myrank/100)//char(48+mod(myrank/10,10))//
     &         char(48+mod(myrank,10))

	  do j = 0, nrank - 1
	     if(j.eq.myrank) then
		    open(1,file='p1024.z'//number//'_'//proc,form='unformatted')
			read(1) ng,ngz,nspace,iseed,np
			close(1)
	     endif
		 call MPI_BARRIER(MPI_COMM_WORLD,ierror)
	  enddo
	  return
	  end

c--   reading data from disk
c---  input character*3 "number" should be specified.
      subroutine rdatafromdisk(ng,ngz,nspace,iseed,size,omep,omeplam,
     &     amax,astep,pconv,vconv,a,redshift,ken,x,y,z,vx,vy,vz,indx,
     &     np,myrank,nrank,inumber,nstep)
      INCLUDE "fftw_f77.i"
      INCLUDE "mpif.h"
      integer ng,ngz,nspace,iseed,np
      real size,omep,amax,astep,pconv,vconv,a,redshift,omeplam,ken
      real x(*),y(*),z(*),vx(*),vy(*),vz(*)
	  integer indx(*)
      integer inumber
      character*1 proc1,proc2,proc3
      character*3 number
      character*80 instring
      integer n,ierror,i,j
	  number = char(48+inumber/100)//char(48+mod(inumber/10,10))//
     &         char(48+mod(inumber,10))
      proc1 = char(48+myrank/100)
      proc2 = char(48+mod(myrank/10,10))
      proc3 = char(48+mod(myrank,10))
      do j = 0, nrank-1
         if(j.eq.myrank) then
            open(21,file='p1024.z'//number//'_'//proc1//proc2//proc3,
     &                form='unformatted')
            read(21)ng,ngz,nspace,iseed,np
            read(21)size,omep,omeplam,amax,astep,pconv,vconv
            read(21)a,redshift
            if(myrank.eq.0)print *,' reading data at a=',a
c           read(21)
            read(21)(indx(i),i=1,np)
c           close(21)
         endif
         call MPI_BARRIER(MPI_COMM_WORLD,ierror)
      enddo
      do j = 0, nrank-1
         if(j.eq.myrank) then
c           open(21,file='p1024.z'//number//'_'//proc1//proc2//proc3,
c    &                form='unformatted')
            read(21)(x(i),i=1,np)
c           close(21)
         endif
         call MPI_BARRIER(MPI_COMM_WORLD,ierror)
      enddo
      do j = 0, nrank-1
         if(j.eq.myrank) then
c           open(21,file='p1024.z'//number//'_'//proc1//proc2//proc3,
c    &                form='unformatted')
            read(21)(y(i),i=1,np)
c           close(21)
         endif
         call MPI_BARRIER(MPI_COMM_WORLD,ierror)
      enddo

      do j = 0, nrank-1
         if(j.eq.myrank) then
c           open(21,file='p1024.z'//number//'_'//proc1//proc2//proc3,
c    &                form='unformatted')
            read(21)(z(i),i=1,np)
            close(21)
         endif
         call MPI_BARRIER(MPI_COMM_WORLD,ierror)
      enddo
      do j = 0, nrank-1
         if(j.eq.myrank) then
            open(21,file='v1024.z'//number//'_'//proc1//proc2//proc3,
     &                form='unformatted')
	        read(21)
	        read(21)
	        read(21)
            read(21)(vx(i),i=1,np)
c           close(21)
         endif
         call MPI_BARRIER(MPI_COMM_WORLD,ierror)
      enddo
      do j = 0, nrank-1
         if(j.eq.myrank) then
c           open(21,file='p1024.z'//number//'_'//proc1//proc2//proc3,
c    &                form='unformatted')
            read(21)(vy(i),i=1,np)
c           close(21)
         endif
         call MPI_BARRIER(MPI_COMM_WORLD,ierror)
      enddo

      do j = 0, nrank-1
         if(j.eq.myrank) then
c           open(21,file='p1024.z'//number//'_'//proc1//proc2//proc3,
c    &                form='unformatted')
            read(21)(vz(i),i=1,np)
            close(21)
         endif
         call MPI_BARRIER(MPI_COMM_WORLD,ierror)
      enddo
      call MPI_BARRIER(MPI_COMM_WORLD,ierror)
      if(myrank.eq.0)print *,' well read data at a=',a

      return
      end

      
